#include "stdafx.h"
#include "NeMessenger.h"
#include "SMSSendWnd.h"
#include "NeMessengerDlg.h"
#include "WorkGroupController.h"
#include "WorkGroupView.h"
#include "main_frame.hpp"
#include "SMSModel.h"
#include "SMSController.h"

#define  SMSPOP_WIDTH     340
#define  SMSPOP_HEIGHT     382

#define  VISIBLE_SMSITEM_COUNT  4
DUI_BEGIN_MESSAGE_MAP(CSMSSendWnd, WindowImplBase, FALSE)
     DUI_ON_MSGTYPE(DUI_MSGTYPE_TEXTCHANGED, NotifyTextChange)
	 DUI_ON_MSGTYPE(DUI_MSGTYPE_RETURN, OnNotifyReturn)
	 DUI_ON_MSGTYPE(DUI_MSGTYPE_ESCAPE, OnEscapeKeyInput)

	 DUI_ON_MSGTYPE(DUI_MSGTYPE_WINDOWINIT, OnPrepare)
	 DUI_ON_MSGTYPE(DUI_MSGTYPE_KILLFOCUS, _OnNotifyKillFocus)
     DUI_ON_MSGTYPE(DUI_MSGTYPE_ITEMCLICK,_OnNotifySMSItemClick)


	  DUI_ON_CLICK_CTRNAME(kSmsPopupMsgTip, _OnCtrlClickMsgTip)
	  DUI_ON_CLICK_CTRNAME(kSmsPopupTelNumberTip,_OnCtrlClickTelTip)
	  DUI_ON_CLICK_CTRNAME(kSmsPopupAddBtn, _OnCtrlAddBtnClick)
	  DUI_ON_CLICK_CTRNAME(kSmsPopupSearchBtn, _OnCtrlSearchBtnClick)
	  DUI_ON_CLICK_CTRNAME(kSmsPopupDelAllBtn, _OnCtrlSmsDelAllBtnClick)
	  DUI_ON_CLICK_CTRNAME(kSmsPopupRecentBtn,  _OnCtrlRecentContactBtnClick)

	  DUI_ON_CLICK_CTRNAME(kSmsPopupListItemDel, _OnCtrlSmsDelBtnClick)

	 
      DUI_ON_CLICK_CTRNAME(kSmsPopupSendBtn,_OnBnClickedButtonSend)
       DUI_ON_CLICK_CTRNAME(kSmsPopupSearchLable, _OnCtrlSearchLabelClick)
	    DUI_ON_CLICK_CTRNAME(kSmsPopupSearchCancel, _OnCtrlSearchCancelClick)
  
DUI_END_MESSAGE_MAP()


DUI_BEGIN_CUSTOM_MSG_MAP(CSMSSendWnd)
     ON_CUSTOM_MSG(WM_SYSKEYDOWN, OnMsgSysKeyDown)
	 ON_CUSTOM_MSG(MSG_CLOSE_SMS_SEARCH, OnMsgCloseSMSSearch)
	 ON_CUSTOM_MSG(MSG_CLOSE_RECENT_CONTACT, OnMsgCloseRecentSMSContact)

DUI_END_CUSTOM_MSG_MAP()

CSMSSendWnd::CSMSSendWnd(CWnd* pParent,const std::vector<CSMSModel::SMSReceiverInfo>& memberVector)
	: m_pSMSController(new CSMSController(this)),
	//  m_pDropTarget(NULL),
	  m_bOnceRcverCountMsgBox(false)
{
	text_padding_ = CDuiRect(0, 0, 0, 0);
	root_node_ = new Node;
	root_node_->data().level_ = -1;
	root_node_->data().child_visible_ = true;
	root_node_->data().has_child_ = true;
	root_node_->data().list_elment_ = NULL;

	m_pSmsSearchWnd = NULL;
	m_pSmsRecentContactWnd = NULL;
	m_pParent = pParent;
    m_receiverVector = memberVector;
	
    //m_rcClient.SetRectEmpty();
}

CSMSSendWnd::~CSMSSendWnd()
{
	/*if (NULL != m_pDropTarget) 
		delete m_pDropTarget;*/
	if (NULL != m_pSMSController )
		delete m_pSMSController;

     SAFE_DELETE(root_node_);
}




void CSMSSendWnd::LoadInitialReceivers(const std::vector<CSMSModel::SMSReceiverInfo>& memberVector){
	for (size_t i=0; i<memberVector.size(); ++i)
	{
		AddChatListItemInfo item;
		item.id = memberVector[i].strID;
		item.nick_name = memberVector[i].strName;

		item.tel = memberVector[i].strCellPhone;

		if (AddSMSReceiver((CString)item.id,(CString)item.nick_name,(CString)item.tel))
		{
			AddNode(item, NULL,NULL);
		}
	}
	//dynamic insert edit-item && seperator-line-item;

	AddListItemEditBoard();

	if (m_pSMSController->GetCurrentReceiverCount() > MAXSMSRECEIVER-1 ) 
	{
		SetEditListItemVisible(false);
		return;
	}
	SetEditListItemVisible(true);
	if (m_pSMSController->GetCurrentReceiverCount() < VISIBLE_SMSITEM_COUNT - 1)
	{
		for (int i=0;i < VISIBLE_SMSITEM_COUNT - 1 - m_pSMSController->GetCurrentReceiverCount(); i++)
		{
			AddListItemSeperator();

		}
	}

}

/*
 FIX:NTALKCL-1275
 [EN] Hide/show the edit item.When the total count of receivers >= MAXSMSRECEIVER, the edit item should be hidden. Otherwise, it's visible. 
*/

void CSMSSendWnd::SetEditListItemVisible(bool bvisible){
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));
	ASSERT(pList!=NULL );
	int InitialCount = pList->GetCount();
	
	for (int i = InitialCount - 1;i >= 0; i--)
	{
		
		CListContainerElementUI* listElem = (CListContainerElementUI* )pList->GetItemAt(i);
		if (listElem->GetUserData() == _T("smseditor")  )
		{
			listElem->SetVisible(bvisible);	
		}
	}

}

/*
 [EN]Delete all seperator-line list items. The seperator lines should be visible only when the empty region of list need to be filled. 
 [CN]ɾбеķָitem.ֻебпհ״ʱָitemҪ̬ϡ

*/
void CSMSSendWnd::RefreshListBeforeOp(){	
   
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));
	ASSERT(pList!=NULL );
	int InitialCount = pList->GetCount();
	int delIndex = pList->GetCount()-1;
	for (int index = 0;index < InitialCount; index++)
	{
		if (delIndex < 0 || delIndex >  pList->GetCount()-1)
		{
			ASSERT(FALSE);
		}
		CListContainerElementUI* listElem = (CListContainerElementUI* )pList->GetItemAt(delIndex);
		if (listElem->GetUserData() == _T("seperator")  )
		{
			pList->RemoveAt(delIndex); // if success, delindex--, it points the end of list;
			                           // if failed, delindex --,too, it points the  node before end node;		
		}
       delIndex --;
	}

}



void CSMSSendWnd::RefreshListAfterOp(){
 
	//When the current receivers total reaches MAXSMSRECEIVER limit, the edit item should be hidden.
    //FIX:NTALKCL-1275:bug1
	if (m_pSMSController->GetCurrentReceiverCount() > MAXSMSRECEIVER-1 ) 
	{
		SetEditListItemVisible(false);
		return;
	}
	SetEditListItemVisible(true);

   //The seperator lines should be visible only when the empty region of list need to be filled. 
	if (m_pSMSController->GetCurrentReceiverCount() < VISIBLE_SMSITEM_COUNT - 1)
	{
		for (int i=0;i < VISIBLE_SMSITEM_COUNT - 1 - m_pSMSController->GetCurrentReceiverCount(); i++)
		{
			AddListItemSeperator();

		}
	}
}
void CSMSSendWnd::_OnCtrlSearchBtnClick(TNotifyUI& msg){

   OnSearchUser();
}

void CSMSSendWnd::_OnCtrlRecentContactBtnClick(TNotifyUI& msg){

   if (m_pSMSController->GetRecentReceiverCount() < 1)
	   return;

   CRect rcSendWnd(0, 0, 0, 0);
   GetWindowRect(GetHWND(),&rcSendWnd);
   CRect rcMenu = msg.pSender->GetPos();	
   rcMenu.top = rcMenu.bottom + 2 + rcSendWnd.top;
   rcMenu.bottom = rcMenu.top + 28*m_pSMSController->GetRecentReceiverCount();
   rcMenu.left += 1 + rcSendWnd.left;
   rcMenu.right = rcMenu.left  + 180;

   if (m_pSmsRecentContactWnd)
   {
	   if (::IsWindow(m_pSmsRecentContactWnd->GetHWND()))
	   {
		   ::DestroyWindow(m_pSmsRecentContactWnd->GetHWND());
	   }
	   delete m_pSmsRecentContactWnd;
	   m_pSmsRecentContactWnd = NULL;
   }
	if (m_pSmsRecentContactWnd == NULL || !::IsWindow(m_pSmsRecentContactWnd->GetHWND()))
	{
		m_pSmsRecentContactWnd = new CSmsRecentContactWnd(this);
		m_pSmsRecentContactWnd->Create(GetHWND(), GetWindowClassName(), WS_POPUP , WS_EX_TOOLWINDOW , rcMenu);

	}
	m_pSmsRecentContactWnd->SetRectInParent(rcMenu);

	::ShowWindow(m_pSmsRecentContactWnd->GetHWND(), SW_SHOWNORMAL);
}

void CSMSSendWnd::_OnCtrlSearchCancelClick(TNotifyUI& msg)
{
	CloseSmsSearchWnd(TRUE,TRUE);
}


LRESULT CSMSSendWnd::OnMsgCloseRecentSMSContact(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_pSmsRecentContactWnd = NULL;
	
	CEditUI* pEditSearch = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
	if (pEditSearch != NULL)
	{
		m_PaintManager.SetFocus(pEditSearch);
	}
	return 0;
}

LRESULT CSMSSendWnd::OnMsgCloseSMSSearch(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_pSmsSearchWnd = NULL;
	MainFrame* pFrame = GET_MESSENGER_DLG()->GetMainFrame();
	if (pFrame != NULL)
	{
		pFrame->SetCurSmsSearchWnd(m_pSmsSearchWnd);
	}
	CEditUI* pEditSearch = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
	if (pEditSearch != NULL)
	{
		m_PaintManager.SetFocus(pEditSearch);
	}
	return 0;
}

void CSMSSendWnd::_OnNotifyKillFocus(TNotifyUI& msg)
{
	if (_tcsicmp(msg.pSender->GetName(), kSmsPopupSearchEdit) == 0)
	{
		msg.pSender->SetVisible(false);
		CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSearchLable));
		if (searchLabel != NULL)
		{
			searchLabel->SetVisible(true);
			if (msg.pSender->GetText().GetLength() == 0)
			{
				searchLabel->SetText(LoadStringFromResource(IDS_STR_SMS_SEARCH));
			}
			else
			{
				CString strSearchWord = msg.pSender->GetText();
				searchLabel->SetText(strSearchWord);
			}
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSmsPopupTelNumberEdit) == 0)
	{
		CEditUI* pTelEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberEdit ));
		CButtonUI* pTelTip = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberTip));
		if (pTelEdit->GetText().GetLength() == 0)
		{
			pTelTip->SetVisible(true);

			pTelEdit->SetVisible(false);
		}		
	
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSmsPopupMsgRichEdit ) == 0)
	{
		if (msg.pSender->GetText().GetLength() ==0)
		{
	
			CButtonUI* pBtnMsgTip = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupMsgTip));
			CEditUI* pEdtMsg =  static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupMsgRichEdit));

			ASSERT(pBtnMsgTip);
			ASSERT(pEdtMsg);

			if(pEdtMsg != NULL && pBtnMsgTip != NULL)
			{
				pBtnMsgTip->SetVisible(true);
				pEdtMsg->SetVisible(false);
			}
		}
	}
   else if (_tcsicmp(msg.pSender->GetName(), kSmsPopupListItemEdit ) == 0)
	{
		CEditUI* EditTel = static_cast<CEditUI*>(m_PaintManager.FindSubControlByName(msg.pSender, kSmsPopupListItemEdit));


		if (EditTel->GetText().IsEmpty())
		{			
			return;
		}
       
		CString tel = (CString)EditTel->GetText();
		m_bOnceRcverCountMsgBox = false;
		if (AddSMSReceiver(  _T(""), _T(""), tel)) //FIX:NTALKCL-1275:BUG2
		{
			RefreshListBeforeOp();
			AddChatListItemInfo item;
			item.id = _T("");
			item.nick_name = _T("");
			item.tel = tel;
			AddNode(item, NULL, NULL);
			RefreshListAfterOp();
			EditTel->SetText(_T(""));

		}		
		
	}
}

void CSMSSendWnd::_OnCtrlSmsDelBtnClick(TNotifyUI& msg){
	
	RefreshListBeforeOp();

   Node* node = (Node*)msg.pSender->GetTag();
   m_pSMSController->RemoveSMSReceiver((CString)node->data().value);

   RemoveNode(node);
   if (m_pSmsSearchWnd && m_pSmsSearchWnd->GetHWND())
   {
	   m_pSmsSearchWnd->UpdateAddBtnAndTooltip((CString)node->data().value,(CString)node->data().tel);
   }
   RefreshListAfterOp();
}

void CSMSSendWnd::_OnCtrlSmsDelAllBtnClick(TNotifyUI& msg){

	RefreshListBeforeOp();
	RemoveAllReceiverList();
	m_pSMSController->RemoveAllSMSReceiver();
	RefreshListAfterOp();
   
}

LRESULT CSMSSendWnd::OnAddUserToSMS(Node* node)
{
	if (true ==AddSMSReceiver((CString)node->data().value,(CString)node->data().text_,(CString)node->data().tel)){
		RefreshListBeforeOp();
		AddNodeFromNode(node);
		RefreshListAfterOp();
	}
	if (m_pSmsSearchWnd && m_pSmsSearchWnd->GetHWND())
	{
		m_pSmsSearchWnd->UpdateAddBtnAndTooltip((CString)node->data().value,(CString)node->data().tel);
		::SetFocus(m_pSmsSearchWnd->GetHWND());
	}
	return 0;
}

void CSMSSendWnd::_OnCtrlSearchLabelClick(TNotifyUI& msg)
{
	msg.pSender->SetVisible(false);
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
	if (searchEdit != NULL)
	{
		searchEdit->SetText(_T(""));
		searchEdit->SetVisible(true);
		searchEdit->SetFocus();
	}
}

void CSMSSendWnd::CloseSmsRecentContactWnd( BOOL bSetFocusToRichEdit)
{
	
	if (m_pSmsRecentContactWnd != NULL && ::IsWindow(m_pSmsRecentContactWnd->GetHWND()))
	{
		m_pSmsRecentContactWnd->Close();
	}

	CEditUI* pEditSearch = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit)); 

	if (pEditSearch != NULL && bSetFocusToRichEdit)
	{
		m_PaintManager.SetFocus(pEditSearch);
	}
}


void CSMSSendWnd::CloseSmsSearchWnd(BOOL bClearSearchEdit, BOOL bSetFocusToRichEdit)
{
	/*if ((g_pProfileWnd != NULL) && (m_pSmsSearchWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_pSmsSearchWnd->GetHWND()))
	{
		g_pProfileWnd->CloseProfileWnd();
	}*/
	if (m_pSmsSearchWnd != NULL && ::IsWindow(m_pSmsSearchWnd->GetHWND()))
	{
		m_pSmsSearchWnd->Close();
	}

	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
	if (searchEdit != NULL && bClearSearchEdit)
	{
		
		searchEdit->SetVisible(false);

		CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSearchLable));
		if (searchLabel != NULL)
		{
			searchLabel->SetVisible(true);
			searchLabel->SetText(LoadStringFromResource(IDS_STR_SMS_SEARCH));
			searchLabel->SetToolTip(LoadStringFromResource(IDS_STR_SMS_SEARCH));
		}
	}

	CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSearchCancel)); 
	if (search_cancel != NULL)
	{
		search_cancel->SetVisible(false);
	}	
	CEditUI* pEditSearch = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit)); 

	if (pEditSearch != NULL && bSetFocusToRichEdit)
	{
		m_PaintManager.SetFocus(pEditSearch);
	}
}


void CSMSSendWnd::OnSearchUser()
{
    g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_SMSSEARCH);
	CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
	if (searchEdit != NULL)
	{
		m_strSearchWord = searchEdit->GetText();
		CString strSearch = m_strSearchWord.Trim(_T("% "));;
		if (strSearch.GetLength() > 1)
		{
			if (m_pSmsSearchWnd == NULL || !::IsWindow(m_pSmsSearchWnd->GetHWND()))
			{
				m_pSmsSearchWnd = new CSmsSearchWnd(this);
				m_pSmsSearchWnd->Create(GetHWND(), _T("SmsSearchWnd"), WS_CHILD, WS_EX_WINDOWEDGE, NULL);
			}
			GET_MESSENGER_DLG()->GetMainFrame()->SetCurSmsSearchWnd(m_pSmsSearchWnd);
			CRect rcSearch(0, 0, 0, 0);
			GetClientRect(m_hWnd, &rcSearch);
			rcSearch.bottom -= 72;
			rcSearch.top = rcSearch.bottom - 56;// m_pChatSearchWnd->GetChatSearchHeight();
			rcSearch.left += 1;
			rcSearch.right -= 1;
			m_pSmsSearchWnd->SetRectInParent(rcSearch);
			::ShowWindow(m_pSmsSearchWnd->GetHWND(), SW_HIDE);
			/*if ((g_pProfileWnd != NULL) && (m_pChatSearchWnd != NULL) && (g_pProfileWnd->GetParentHwnd() == m_pChatSearchWnd->GetHWND()))
			{
				g_pProfileWnd->CloseProfileWnd();
			}*/

			
			if(GET_MESSENGER_DLG()->GetMainFrame())
			{
				GET_MESSENGER_DLG()->GetMainFrame()->SetRequestSearch(strSearch, SEND_SMS_SEARCH);

			}
			CLabelUI* pSearchResult = m_pSmsSearchWnd->GetNosearchResultLabel();
			if (pSearchResult != NULL)
			{
				pSearchResult->SetVisible(false);
			}
			//CEditUI* searchEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
			CButtonUI* searchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSearchBtn));
			if (searchEdit != NULL && searchLabel != NULL)
			{
				m_strSearchWord = searchEdit->GetText();
				searchEdit->SetVisible(false);
				searchLabel->SetVisible(true);
			}

			CButtonUI* search_cancel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSearchCancel));
			if (search_cancel != NULL)
			{
				search_cancel->SetVisible(true);
			}
			SetFocus(m_pSmsSearchWnd->GetHWND());
		}
		else
		{
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING169));
			searchEdit->SetVisible(true);
			searchEdit->SetFocus();

		}
	}	
}



/*
bool CSMSSendWnd::RemoveNode(CListUI* pList,Node* node)
{
	if (!node) return false;


	int nCount = node->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = node->child(i);
		RemoveNode(pList,child);
	}

	if (pList != NULL)
	{
		pList->Remove(node->data().list_elment_);
	}
	node->parent()->remove_child(node);
	delete node;

	return true;
}*/
bool CSMSSendWnd::RemoveNode(Node* node)
{
	if (!node || node == root_node_) return false;


	int nCount = node->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = node->child(i);
		RemoveNode(child);
	}
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));
	if (pList != NULL)
	{
		pList->Remove(node->data().list_elment_);
	}
	CAddChatWnd* pAddChatWnd = GET_MESSENGER_DLG()->GetWorkGroupController()->GetWorkView()->GetAddChatWnd();
	if(pAddChatWnd != NULL)
	{
		pAddChatWnd->UpdateCheckStatus(node->data().value, true);
	}

	node->parent()->remove_child(node);
	delete node;

	
	return true;
}


/*
void CSMSSendWnd::GetAllSmsReceiver(){
 
  for (int i = 0; i < root_node_->num_children(); ++i)
  {
	 
	  Node* child = root_node_->child(i);
	  CString strID = child->data().value;
	  CString strName = child->data().text_;
      CString strCellPhone = child->data().tel;
	  m_pSMSController->AddSMSReceiver(  strID,  strName,  strCellPhone );
  }

}*/



void CSMSSendWnd::InitSkin()
{
	TCHAR szStylesPath[_MAX_PATH];

	VERIFY(::GetModuleFileName(AfxGetApp()->m_hInstance, szStylesPath, _MAX_PATH));

	CString strStylesPath = szStylesPath;
	int nIndex  = strStylesPath.ReverseFind(_T('\\'));
	if (nIndex > 0) 
	{
		strStylesPath = strStylesPath.Left(nIndex);
	}
	else 
	{
		strStylesPath.Empty();
	}
	strStylesPath += _T("\\IMAGES\\style\\");

	CXTPSkinManager* pSkinManager = XTPSkinManager();

	pSkinManager->ApplyWindow(GetHWND());
	CXTPSkinManagerSchema* pSchema = pSkinManager->CreateSchema(GetAppImgDir()+_T("\\style\\Ntalk.cjstyles"), _T("Base1.ini"));
	pSkinManager->SetWindowTheme(GetHWND(), pSchema);
	CMDTARGET_RELEASE(pSchema);
}

void CSMSSendWnd::AddListItemSeperator(){

	TCHAR szBuf[MAX_PATH] = {0};
	CDialogBuilder  m_dlgBuilder;
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));

	CListContainerElementUI* pListElement = NULL;
	pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create(_T("smsListElement.xml"), (UINT)0, NULL, &m_PaintManager));

	if (pListElement == NULL)
		return ;

	pListElement->SetUserData(_T("seperator"));
	CHorizontalLayoutUI* EditBoard = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemEditBoard));
	if (EditBoard)
	{
		EditBoard->SetVisible(false);
	}
	CButtonUI* pDelCtrl = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemDel));
	if (pDelCtrl != NULL)
	{
		pDelCtrl->SetVisible(false);
	}

	int index = 0;
	index = pList->GetCount();
	
	if (pList!=NULL && !pList->AddAt(pListElement, index))
	{
		delete pListElement;		
	}	
}
//Add list item: edit telnumber;
void CSMSSendWnd::AddListItemEditBoard(){

	TCHAR szBuf[MAX_PATH] = {0};
	CDialogBuilder  m_dlgBuilder;
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));

	CListContainerElementUI* pListElement = NULL;
	pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create(_T("smsListElement.xml"), (UINT)0, NULL, &m_PaintManager));

	if (pListElement == NULL)
		return ;

	pListElement->SetUserData(_T("smseditor"));
	CHorizontalLayoutUI* ItemBoard = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemBoard));
	if (ItemBoard)
	{
		ItemBoard->SetVisible(false);
	}
	CHorizontalLayoutUI* EditBoard = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemEditBoard));
	if (EditBoard)
	{
		EditBoard->SetVisible(true);
	}
	CEditUI* EditTel = static_cast<CEditUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemEdit));
	if (EditTel)
	{
		EditTel->SetMaxChar(16);
		EditTel->SetNumberOnlyCustom(true);
	}
	CButtonUI* pDelCtrl = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemDel));
	if (pDelCtrl != NULL)
	{
		pDelCtrl->SetVisible(false);
	}

	int index = 0;
	index = pList->GetCount();

	if (pList!=NULL && !pList->AddAt(pListElement, index))
	{
		delete pListElement;		
	}	
}

Node* CSMSSendWnd::AddNode(const AddChatListItemInfo& item, Node* parent, const NE_MEMBER_DATA* pMembereData)
{
	if (!parent)
		parent = root_node_;

	TCHAR szBuf[MAX_PATH] = {0};
    CDialogBuilder  m_dlgBuilder;
    CListContainerElementUI* pListElement = NULL;
	 pListElement = static_cast<CListContainerElementUI*>(m_dlgBuilder.Create(_T("smsListElement.xml"), (UINT)0, NULL, &m_PaintManager));
 
    if (pListElement == NULL)
        return NULL;

	Node* node = new Node;

	node->data().level_ = parent->data().level_ + 1;	
	
	node->data().has_child_ = false;	

	node->data().folder_ = false;

	node->data().child_visible_ = false;

	node->data().text_ = item.nick_name;
	node->data().value = item.id;
	node->data().tel = item.tel;

	node->data().list_elment_ = pListElement;	

	pListElement->SetVisible(true);

	CDuiRect rcPadding = text_padding_;
	
	pListElement->SetPadding(rcPadding);	

	CDuiString html_text;
	

	CLabelUI* nick_name = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement,kSmsPopupListItemName));
	if (nick_name != NULL)
	{

		nick_name->SetTextColor(RGB(141, 147, 152));
		//nick_name->SetShowHtml(true);
		nick_name->SetText(item.nick_name);
		nick_name->SetToolTip(item.nick_name);
		
	}

	CLabelUI* sms_item_tel = static_cast<CLabelUI*>(m_PaintManager.FindSubControlByName(pListElement,kSmsPopupListItemTel));
	if (sms_item_tel != NULL)
	{	
		
		sms_item_tel->SetText(item.tel);
	}

	CButtonUI* pDelCtrl = static_cast<CButtonUI*>(m_PaintManager.FindSubControlByName(pListElement, kSmsPopupListItemDel));
	if (pDelCtrl != NULL)
	{
		pDelCtrl->SetTag((UINT_PTR)node);
	}
    /*[EN]Insert the valid contact node at the end of valid nodes; 
      [CN]ϵnode뵽ϵĩβlistseperator/edit item˳ӡ
	*/
	int index = root_node_->num_children(); 

	pListElement->SetUserData(_T("node"));
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));
	if (pList!=NULL && !pList->AddAt(pListElement, index))
	{
		delete pListElement;
		delete node;
		node = NULL;
	}
	if (node != NULL)
	{
		parent->add_child(node);
	}
	
	CAddChatWnd* pAddChatWnd = GET_MESSENGER_DLG()->GetWorkGroupController()->GetWorkView()->GetAddChatWnd();
	if(pAddChatWnd != NULL)
	{
		pAddChatWnd->UpdateCheckStatus(item.id, false);
	}
	return node;
}


void CSMSSendWnd::SetSenderText( ){
	CButtonUI* pBtnTelNumberTip = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberTip));// input number
	CButtonUI* pBtnTelNumberEdit = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberEdit));// input number
	GT_MY_USER_DATA myUserInfo;
	g_pMessengerActor->GetMyUserInfo(myUserInfo);
	CString strCellPhone(myUserInfo.sMyPage.strCphNo);
	if (!strCellPhone.IsEmpty())
	{
		pBtnTelNumberTip->SetVisible(false);
		pBtnTelNumberEdit->SetVisible(true);
		pBtnTelNumberEdit->SetText(strCellPhone);
	}
	if (!m_pSMSController->m_strMyCellPhone.IsEmpty())
	{
		/*m_pSMSController->m_strMyCellPhone.Remove('-');
		m_pSMSController->m_strMyCellPhone.Remove('+');*/

		pBtnTelNumberTip->SetVisible(false);
		pBtnTelNumberEdit->SetVisible(true);
		pBtnTelNumberEdit->SetText(m_pSMSController->m_strMyCellPhone);

	}
	else{
		pBtnTelNumberTip->SetText(LoadStringFromResource(IDS_STR_INPUT_SMSRECEIVER));
	}
}



void CSMSSendWnd::OnPrepare(TNotifyUI& msg)
{
	InitSkin();

	AssignDropTarget();
	CLabelUI* pTitle = static_cast<CLabelUI*>(m_PaintManager.FindControl(kSmsPopupTitle)); // title
	pTitle->SetText(LoadStringFromResource(IDS_STRING293));

	SetSenderText();
	CRichEditUI* pInputTip = static_cast<CRichEditUI*>(m_PaintManager.FindControl(kSmsPopupMsgRichEdit));	
	pInputTip->SetLimitText(80);
	pInputTip->SetWantReturn(true);

	CEditUI* pInputEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberEdit));
	pInputEdit->SetMaxChar(16);
	pInputEdit->SetNumberOnlyCustom(true);

	CButtonUI* pBtnAdd = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupAddBtn));//add 
	pBtnAdd->SetText(LoadStringFromResource(IDS_STRING581));

	CButtonUI* pBtnDel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupDelAllBtn));//del
	pBtnDel->SetText(LoadStringFromResource(IDS_STR_SMS_DELALL));

	CButtonUI* pBtnRecent = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupRecentBtn ));//recent
	pBtnRecent->SetText(LoadStringFromResource(IDS_STR_SMS_RECENT));

	
	CLabelUI* pBtnMsgTip = static_cast<CLabelUI*>(m_PaintManager.FindControl(kSmsPopupMsgTip ));//MSG TIP
	pBtnMsgTip->SetText(LoadStringFromResource(IDS_STRING547));

	CButtonUI* pSearchLabel = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSearchLable));
    pSearchLabel->SetText(LoadStringFromResource(IDS_STR_SMS_SEARCH)); 

	CButtonUI* pSendBtn = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupSendBtn));
	pSendBtn->SetText(LoadStringFromResource( IDS_STRING577)); 

	
	CString strTmpClassName = _T("");
	strTmpClassName.Format(_T("Ntalk_RecvList_%X%X%X"),
		GetTickCount(),
		GetCurrentProcessId(),
		GetCurrentThreadId());
	

	g_pMessengerActor->GetWASActor()->RegisterObserver(this);	
    RemoveAllReceiverList();
	m_pSMSController->RemoveAllSMSReceiver();
	m_pSMSController->Load();
	LoadInitialReceivers(m_receiverVector);
}


//FIX:NTALKCL-1254
void CSMSSendWnd::AddUser(std::vector<NE_MEMBER_DATA>& vAddUsers)
{
	m_bOnceRcverCountMsgBox = false;
	InitMemberList(vAddUsers);	
}




LRESULT CSMSSendWnd::OnCloseSmsSearchWnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	m_pSmsSearchWnd = NULL;
	MainFrame* pFrame = GET_MESSENGER_DLG()->GetMainFrame();
	if (pFrame != NULL)
	{
		pFrame->SetCurSmsSearchWnd(m_pSmsSearchWnd);
	}
	CEditUI* pEditSearch = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));	

	if (pEditSearch != NULL)
	{
		m_PaintManager.SetFocus(pEditSearch);
	}
	return 0;
}

/*
void CSMSSendWnd::AddSMSReceiverFromInfo(CString strID, CString strName, CString strCellphone){



	if (AddSMSReceiver( strID,  strName,  strCellphone))
	{
		AddChatListItemInfo item;
		item.id = strID;
		item.nick_name = strName;
		item.tel = strCellphone;
		AddNode(item, NULL, NULL);
	}
}*/

void CSMSSendWnd::AddSMSReceiverNode(CString strID, CString strName, CString strCellphone){
	
		AddChatListItemInfo item;
		item.id = strID;
		item.nick_name = strName;
		item.tel = strCellphone;
		AddNode(item, NULL, NULL);
}


LRESULT CSMSSendWnd::OnNcHitTest(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	if (HTCAPTION == WindowImplBase::OnNcHitTest( uMsg,  wParam,  lParam,  bHandled))
	{
       return HTCAPTION;
	}
	else{
	  return HTCLIENT;
	}
}

void CSMSSendWnd::DoSMSInvite()
{
	GET_MESSENGER_DLG()->GetWorkGroupController()->OpenAddUserDlg(this, ADD_USER_FROM_SMS);
	GET_MESSENGER_DLG()->GetWorkGroupController()->GetWorkView()->GetAddChatWnd()->SetParentSmsSendWnd(this);
	GET_MESSENGER_DLG()->GetWorkGroupController()->GetWorkView()->GetAddChatWnd()->SetInChatRoom(_T(""));
}

void CSMSSendWnd::RemoveAllReceiverList()
{
	
	CListUI* pList = static_cast<CListUI*>(m_PaintManager.FindControl(kSmsPopupAddList));
	if (NULL == pList)
	{
		return;
	}	
	//[EN]Delete valid contact node in the list;
	//[CN]ֻɾϷϵ˽㡣edit node
	int InitialCount = pList->GetCount();
	int delIndex = pList->GetCount()-1;
	for (int i = 0;i < InitialCount; i++)
	{
		if (delIndex < 0 || delIndex >  pList->GetCount()-1)
		{
			ASSERT(FALSE);
		}
		CListContainerElementUI* listElem = (CListContainerElementUI* )pList->GetItemAt(delIndex);
		if (listElem->GetUserData() == _T("node")  )
		{
			pList->RemoveAt(delIndex);		
		}
		delIndex --;
	}
	//pList->RemoveAll();

	int nCount = root_node_->num_children();
	for (int i = nCount - 1; i >=0;  i--)
	{
		Node* child = root_node_->child(i);
		RemoveNode(child);
	}
	delete root_node_;
	root_node_ = new Node;
	root_node_->data().level_ = -1;
	root_node_->data().child_visible_ = true;
	root_node_->data().has_child_ = true;
	root_node_->data().list_elment_ = NULL;
}

void CSMSSendWnd::AddNodeFromNode(Node* pNode){
	
	AddChatListItemInfo item;

	item.folder = false;
	item.id = pNode->data().value;
	item.nick_name = pNode->data().text_;
	item.tel = pNode->data().tel;


	AddNode(item,NULL,NULL);
}


void CSMSSendWnd::InitMemberList(const std::vector<NE_MEMBER_DATA> &memberVector)
{
	std::vector<AddChatListItemInfo> memberToAdd;

	for (size_t i=0; i<memberVector.size(); ++i)
	{
		AddChatListItemInfo item;
		item.id = memberVector[i].strUserId.c_str();
		item.nick_name = memberVector[i].strName.c_str();		
		item.tel = memberVector[i].strCellPhone.c_str();		
		if (AddSMSReceiver((CString)item.id,(CString)item.nick_name,(CString)item.tel))
		{
			memberToAdd.push_back(item);			
		}
	}
    //[EN] Only when the memberToAdd is not empty, list UI need to be updated.FIX:NTALKCL-1275:BUG2
	if (memberToAdd.size() > 0)
	{
		RefreshListBeforeOp();
		for (size_t i=0; i<memberToAdd.size(); ++i){
			AddChatListItemInfo item = memberToAdd[i];
			AddNode(item, NULL, NULL);
		}
		RefreshListAfterOp();
	}
	
}

void CSMSSendWnd::OnNotifyReturn(TNotifyUI& msg)
{
	if (_tcsicmp(msg.pSender->GetName(), _T("edit_sms_msg")) == 0)
	{
		CRichEditUI* pEditChat =  static_cast<CRichEditUI*>(msg.pSender);
		if (msg.wParam == WM_KEYDOWN)
		{
			if (GetKeyState(VK_SHIFT) < 0 || GetKeyState(VK_CONTROL) < 0)		
			{
				pEditChat->ReplaceSel(_T("\r\n"), true);
			}			
		}
		if(msg.wParam == WM_SYSKEYDOWN)
		{
			if (GetKeyState(VK_MENU) < 0 )		
			{
				pEditChat->ReplaceSel(_T("\r\n"), true);
			}			
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSmsPopupSearchEdit) == 0)
	{
		if (msg.wParam == WM_KEYDOWN)
		{
			OnSearchUser();
		}
	}
	else if (_tcsicmp(msg.pSender->GetName(), kSmsPopupListItemEdit) == 0)
	{
      
		m_PaintManager.SetFocus(NULL);
	}
	
}



void CSMSSendWnd::_OnBnClickedButtonSend(TNotifyUI& msg)
{
	if(m_pSMSController->GetCurrentReceiverCount() <1)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING550));
		return;
	}
	CString strContent;
	CRichEditUI* pMsgEdit = static_cast<CRichEditUI*>(m_PaintManager.FindControl(kSmsPopupMsgRichEdit));
	strContent = pMsgEdit->GetText();	
	if (L"" == strContent)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING559));
		return;
	}

	CString strSender;
	CEditUI* pInputEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberEdit));
	strSender = pInputEdit->GetText();	
	strSender.Remove('+');
	strSender.Remove('-');

	if (L"" == strSender)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING558) );
		return;
	}

	trid_t trid;
	g_pMessengerActor->GetWASActor()->RequestSMS(strContent, m_pSMSController->GetReceiverTelNums(), strSender, &trid );
	m_tridList.push_back(trid);

	RefreshListBeforeOp();
	RemoveAllReceiverList();
	RefreshListAfterOp();

	m_pSMSController->UpdateRecentSMSReceiver();
}

void CSMSSendWnd::OnBnClickedButtonDelAllReceiver()
{
    RefreshListBeforeOp();
	RemoveAllReceiverList();
    RefreshListAfterOp();
}

/*
bool CSMSSendWnd::IsCloseMsg( MSG* pMsg )
{
	bool result = false;
	if( (pMsg->message == WM_CLOSE) ||
		(pMsg->message == WM_KEYDOWN && pMsg->wParam == VK_ESCAPE) || 
		(pMsg->message == WM_SYSCOMMAND && pMsg->wParam == SC_CLOSE) ||
		(pMsg->message == WM_SYSKEYDOWN && pMsg->wParam == VK_F4)||
		(pMsg->message == WM_COMMAND && HIWORD(pMsg->wParam) == 0 && LOWORD(pMsg->wParam) == IDCANCEL))
		result = true;

	return result;
}*/


void CSMSSendWnd::AssignDropTarget()
{
	m_DT.Register( CWnd::FromHandle(m_hWnd));
	m_DT.SetSMSSendDlg(this);

}

void CSMSSendWnd::OnFinalMessage( HWND hWnd )
{
	g_pMessengerActor->GetWASActor()->UnRegisterObserver(this);	
	g_pMessengerActor->RequestUregFavoriteFromPOI(REGPOIGROUP_SMSSEARCH);
     RemoveAllReceiverList();
	if (m_pSmsRecentContactWnd)
	{
		if (::IsWindow(m_pSmsRecentContactWnd->GetHWND()))
		{
			::DestroyWindow(m_pSmsRecentContactWnd->GetHWND());
		}
		delete m_pSmsRecentContactWnd;
		m_pSmsRecentContactWnd = NULL;
	}
	
	m_DT.Revoke();
	delete this;
}

bool CSMSSendWnd::OnGTWASActor_ResponseSMS( IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, const NE_SMS_DATA &smsCount )
{
	std::list<trid_t>::iterator findTrid = std::find(m_tridList.begin(), m_tridList.end(), trid);
	if (findTrid == m_tridList.end())
		return true;

	m_tridList.remove(*findTrid);

	if (eErrorCode == wasError_None)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING548));
	}
	else if(eErrorCode == wasError_Invalid_Authorization)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING_SMS_INVALID_AUTHORIZATION));

	}
	else if(eErrorCode == wasError_Lack_Point)
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING_SMS_LACK_SEND_POINT));
	}
	else
	{
		NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING549));

	}

	return false;
}




LRESULT CSMSSendWnd::OnReciverListDelUser( WPARAM wParam, LPARAM lParam )
{
	CWndSMSRecvList::USER_ITEM_INFO* pUserInfo = (CWndSMSRecvList::USER_ITEM_INFO*)lParam;
	if (!pUserInfo)
		return 0L;
	m_pSMSController->RemoveSMSReceiver(pUserInfo->strID);

	return 1L;
}

void CSMSSendWnd::SetWindowPosition(/*CRect rcParent*/)
{
	CRect rcMonitor(0, 0, 0, 0);
	MONITORINFO oMonitor = {};
	oMonitor.cbSize = sizeof(oMonitor);
	::GetMonitorInfo(::MonitorFromWindow(m_pParent->GetSafeHwnd(), MONITOR_DEFAULTTONEAREST), &oMonitor);
	rcMonitor = oMonitor.rcWork;
	int nLeft = rcMonitor.left + rcMonitor.Width()/2 -SMSPOP_WIDTH/2;
	int nTop = rcMonitor.top + rcMonitor.Height()/2 -SMSPOP_HEIGHT/2;
  
	::SetWindowPos(m_hWnd, NULL, nLeft,nTop, SMSPOP_WIDTH, SMSPOP_HEIGHT, SWP_FRAMECHANGED | SWP_SHOWWINDOW);
}


bool CSMSSendWnd::AddSMSReceiver(CString strID, CString strName, CString strCellPhone)
{
	int nReceiverCount=m_pSMSController->GetCurrentReceiverCount();
	
	if (nReceiverCount > MAXSMSRECEIVER-1)
	{
		if (false == m_bOnceRcverCountMsgBox)
		{	
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING469));
            m_bOnceRcverCountMsgBox = true;
		}
		return false;
	}
	if (L"" ==strCellPhone)
	{
		CString strErrMsg;
		strErrMsg.Format(LoadStringFromResource(IDS_STRING562),strName,strName);
		NMessageBox(CWnd::FromHandle(m_hWnd),strErrMsg);
		return false;
	}
	else
	{
		return m_pSMSController->AddSMSReceiver(strID, strName, strCellPhone);
	}	
}

CDuiString CSMSSendWnd::GetSkinFile()
{
	return _T("smsPopWnd.xml");
}

CDuiString CSMSSendWnd::GetSkinFolder()
{
	return _T("skin\\nTalkRes");
}

LPCTSTR CSMSSendWnd::GetWindowClassName() const
{
	return _T("SMSSendWnd");

}

void CSMSSendWnd::InitWindow()
{
  SetWindowPosition();
}
//Get the bytes count of string(asc2 string,multibytes mixed string, unicode string, etc)

unsigned int CSMSSendWnd::_GetStringBytesCount(CString& str){
	char* szSend = StringToChar(str);
	if (szSend == NULL)
		return 0;

	int nLen = strlen(szSend);
	delete [] szSend; 
	szSend = NULL;
    return nLen;
}
//Trunk the too long string to below 80 bytes( <= 80 bytes);by bisection method(ַ)

void CSMSSendWnd::_TrunkTextToLimitBytes(CString& strInWindow){
   int minLength = 80/2;
   int maxLength = 80;
   int mid = minLength;
   int nbytes = 0;
   while (maxLength > minLength)
   {
     mid = (minLength + maxLength) /2;
	 CString strTemp = strInWindow.Left(mid);
     nbytes = _GetStringBytesCount(strTemp);
	 if (nbytes == 80)
	 {
		 break;
	 }
	 if (nbytes < 80)
	 {
		 minLength = mid + 1;

	 }
	 else{
		 maxLength = mid -1;
	 }

   }
  
   CString strTrunked = strInWindow.Left(mid);
   if (_GetStringBytesCount(strTrunked) > 80)
   {
	   strInWindow = strInWindow.Left(mid - 1);
   }
   else{

	   strInWindow = strInWindow.Left(mid);
   }

}


void CSMSSendWnd::NotifyTextChange( TNotifyUI& msg )
{
    if (msg.pSender->GetName() == kSmsPopupMsgRichEdit)
    {
		CRichEditUI* pInputTip = static_cast<CRichEditUI*>(m_PaintManager.FindControl(kSmsPopupMsgRichEdit));
		CString strInWindow = pInputTip->GetText();	
	

		int nLen = _GetStringBytesCount(strInWindow);
		
		CString strTip;
		strTip.Format(L"%d Byte",nLen);
		CTextUI* pBytesTip = static_cast<CTextUI*>(m_PaintManager.FindControl(kSmsPopupMsgBytesTipText ));
		pBytesTip->SetText(strTip); 
      //Fix:NTALKCL-1269; BUG2

		if (nLen >= 80)
		{
			if (nLen > 80) // we need trunk the word string to below 80 bytes.
			{
				_TrunkTextToLimitBytes(strInWindow);
				pInputTip->SetText(strInWindow);

				nLen = _GetStringBytesCount(strInWindow);
				strTip.Format(L"%d Byte",nLen);

				pBytesTip->SetText(strTip);	
			}
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING547));

		}
    }
	else if (msg.pSender->GetName() == kSmsPopupTelNumberEdit || msg.pSender->GetName() == kSmsPopupListItemEdit)
	{
		//CEditUI* pInputTip = static_cast<CEditUI*>(m_PaintManager.FindControl(msg.pSender->GetName()));
		CString strInWindow = msg.pSender->GetText();	

		char* szSend = StringToChar(strInWindow);
		if (szSend == NULL)
			return;

		int nLen = strlen(szSend);
		delete [] szSend; 
		szSend = NULL;
	    nLen = _VerifyEditValue(msg);
		
		if (nLen >= 16)
		{
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING553));
		}

		
	}

}

void CSMSSendWnd::OnEscapeKeyInput(TNotifyUI& msg) 
{

	if (msg.pSender->GetName() == kSmsPopupTelNumberEdit || msg.pSender->GetName() == kSmsPopupListItemEdit ){

		CEditUI* pInputTip =(CEditUI*)msg.pSender;// static_cast<CEditUI*>(m_PaintManager.FindControl(msg.pSender->GetName()));
		CString strInWindow = pInputTip->GetText();    
		
		
        pInputTip->SetText(_T(""));
		m_PaintManager.SetFocus(NULL);
		
	}
}


void CSMSSendWnd::_OnCtrlClickMsgTip( TNotifyUI& msg )
{
	if (msg.pSender->GetName() == kSmsPopupMsgTip )
	{
		CButtonUI* pBtnMsgTip = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupMsgTip));
		CEditUI* pEdtMsg =  static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupMsgRichEdit));

		ASSERT(pBtnMsgTip);
		ASSERT(pEdtMsg);

		if(pEdtMsg != NULL && pBtnMsgTip != NULL)
		{
			pBtnMsgTip->SetVisible(false);
			pEdtMsg->SetVisible(true);
			pEdtMsg->SetFocus();
		}

	}
}


void CSMSSendWnd::_OnCtrlClickTelTip(TNotifyUI& msg){

	if (msg.pSender->GetName() == kSmsPopupTelNumberTip )
	{
		CButtonUI* pTelTip = static_cast<CButtonUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberTip));
		pTelTip->SetVisible(false);
		CEditUI* pTelEdit = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupTelNumberEdit ));
		pTelEdit->SetVisible(true);
		pTelEdit->SetFocus();
	} 

}



void CSMSSendWnd::_OnCtrlAddBtnClick( TNotifyUI& msg )
{
  DoSMSInvite();
}



LRESULT CSMSSendWnd::OnMsgSysKeyDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	if (VK_F4 == wParam)
	{
		bHandled = TRUE;
		 Close();		
	}
	return TRUE;
}

void CSMSSendWnd::_OnNotifySMSItemClick( TNotifyUI& msg )
{
	
	if (_tcsicmp(msg.pSender->GetClass(), _T("ListContainerElementUI")) == 0)
	{
	   if (msg.pSender->GetUserData() == _T("smseditor"))
		{
			CHorizontalLayoutUI* EditBoard = static_cast<CHorizontalLayoutUI*>(m_PaintManager.FindSubControlByName(msg.pSender, kSmsPopupListItemEditBoard));
			if (EditBoard)
			{
				EditBoard->SetVisible(true);
			}
			CEditUI* EditTel = static_cast<CEditUI*>(m_PaintManager.FindSubControlByName(msg.pSender, kSmsPopupListItemEdit));
			EditTel->SetVisible(true);
		
			EditTel->SetFocus();
            
		}
	
	}
	
}


LRESULT CSMSSendWnd::OnKeyDown( UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled )
{
	bHandled = FALSE;
	if ((TCHAR)wParam == VK_ESCAPE)
	{
		Close();
	//	bHandled = TRUE;
	}

	if((wParam == 'F' || wParam == 'f') && GetKeyState(VK_CONTROL) < 0)
	{
		CEditUI* pEditSearch = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupSearchEdit));
		if (pEditSearch != NULL)
		{
			pEditSearch->SetText(_T(""));
			pEditSearch->SetVisible(true);
			pEditSearch->SetFocus();
		}
		bHandled = TRUE;
	}
	return S_OK; 
}

std::vector<CSMSModel::SMSReceiverInfo>* CSMSSendWnd::GetSMSReceivers()
{
	return &(m_pSMSController->GetSMSModel()->m_receiverVector);
}



BOOL CSMSSendWnd::FindTelInSMSWnd(CString strTelNumber){
	return m_pSMSController->FindTelInSMSWnd(strTelNumber);
}

LRESULT CSMSSendWnd::OnMouseWheel( UINT , WPARAM , LPARAM , BOOL& bHandled )
{
	CEditUI* EditTel = static_cast<CEditUI*>(m_PaintManager.FindControl(kSmsPopupListItemEdit));
	ASSERT(EditTel);

	if(NULL != EditTel)
	{
		if(EditTel->IsFocused())
		{
			m_PaintManager.SetFocus(NULL);
		}
	}

	bHandled = FALSE; // it should be false for mouse wheel
	return S_OK;
}

int CSMSSendWnd::_VerifyEditValue(TNotifyUI& msg)
{
	CEditUI *pEdit = static_cast<CEditUI*>(msg.pSender);
	ASSERT(pEdit);
    int nLen = 0;
	if(pEdit != NULL)
	{
		CString strValue = pEdit->GetText();


		char* szSend = StringToChar(strValue);
		if (szSend == NULL)
			return 0;

		nLen = strlen(szSend);

		delete [] szSend; 
		szSend = NULL;
		int strLength = strValue.GetLength();

		bool bFind = false;
		vector<TCHAR> vecChars;
		for(int i = 0; i < strLength; i++)
		{
			TCHAR ch = strValue.GetAt(i);
			if(!(( ch >= 0x30 &&  ch <= 0x39) || 
				ch == 0x2D ||  ch == 0x2B 
				||  ch == 0x0D ||  ch == 0x0A || ch ==0x08 || ch ==22 || ch == 3))	
			{
				bFind = true;
				vecChars.push_back(ch);
			}
		}

		if(bFind)
		{
			for(int i = 0; i < vecChars.size(); i++)
			{
				strValue.Remove(vecChars[i]);
			}
			pEdit->SetText(strValue);

			CString strInWindow =pEdit->GetText();	

			char* szSend = StringToChar(strInWindow);
			if (szSend == NULL)
				return 0;

			nLen = strlen(szSend);
			delete [] szSend; 
			szSend = NULL;

		//	OnCharInputNumber(msg);
			NMessageBox(CWnd::FromHandle(m_hWnd), LoadStringFromResource(IDS_STRING552));
		}
	
	}
	return nLen;
}
////FIX:NTALKCL-1274
void CSMSSendWnd::InitializeMsgPopOnce()
{
  m_bOnceRcverCountMsgBox = false;
}
